<?php 
	
	/*	
	*	function.php
	*	---------------------------------------------------------------------
	*	This file contains all important functions and features of the theme.
	*	---------------------------------------------------------------------
	*/	
	
	/************** Frequently Used Image Sizes In The Theme *************/
	
		add_image_size('tabligh-post-detail',870,475, true);			/* Post Detail Image ********(1) */
		add_image_size('tabligh-team-detail',470,530, true);			/* Team Detail Image ********(2) */
		add_image_size('tabligh-course-detail',1170,475, true);			/* Course Detail Image ******(3) */
		add_image_size('tabligh-services-detail',570,577, true);		/* Services Detail Image ****(4) */
		add_image_size('tabligh-sermons-detail',786,480, true);			/* Sermons Detail Image *****(5) */
		add_image_size('tabligh-event-detail',870,400, true);			/* Events Detail Image ******(6) */
	
		
	/************** include essential files to enhance framework functionality *************/
	
		include_once(get_template_directory().	'/includes/files-loader.php');		/* It includes all javacript and style in theme */	
		include_once(get_template_directory().	'/includes/plugins.php');			/* It all the plugins required for the theme */	
		include_once(get_template_directory().	'/includes/core-functions.php');	/* It includes all required functions of theme */
		include_once(get_template_directory().	'/includes/breadcrumbs.php');		/* It includes breadcrumbs of theme pages */
		include_once(get_template_directory().	'/includes/comment-layout.php');	/* It includes custom Comment Layout of theme */
		include_once(get_template_directory().	'/includes/pagination.php');		/* It includes pagination of theme */
		if ( class_exists( 'ReduxFramework' )){
			include_once(get_template_directory().	'/includes/loadstyle.php');			/* It includes default styles of theme */
		}
	
		/* Add Redux Framework */
		if ( !isset( $tabligh_options ) && file_exists( get_template_directory() . '/ReduxFramework/theme-options.php' ) ) {
			require_once( get_template_directory() . '/ReduxFramework/theme-options.php' );
		}
		
		include_once(get_template_directory().	'/includes/headers/headers.php');			/* Theme headers */	
		include_once(get_template_directory().	'/includes/footers/footers.php');			/* Theme footers */	
		
		/* Super Object */
		include_once(get_template_directory().	'/framework/extensions/super-object.php'); 	/* Super object function */
		
		/* Dummy File Load */
		require get_template_directory() . '/inc/dummy-data/dummy-file.php';
		
	/* Theme API Key Validation Script */	
		function validation_script_admin() {
		
			wp_register_script( 'api-validation', get_template_directory_uri().'/inc/API/validation.js', array('jquery'),null,true );
			wp_enqueue_style( 'tvalidation-stylesheet', get_template_directory_uri().'/inc/API/validation.css' );

			wp_localize_script('api-validation','ajax_login_object',array(
				'ajaxurl' => admin_url('admin-ajax.php'),
				'ajax_nonce' => wp_create_nonce( "secure_nonce_name" )
			));
			
			wp_enqueue_script( 'jquery' );
			wp_enqueue_script('api-validation');
		}

		add_action('admin_enqueue_scripts','validation_script_admin');

		if(is_admin()) {
			require get_template_directory().'/inc/API/validation.php';
		}
		
		// Disables the block editor from managing widgets in the Gutenberg plugin.
		add_filter( 'gutenberg_use_widgets_block_editor', '__return_false' );

		// Disables the block editor from managing widgets.
		add_filter( 'use_widgets_block_editor', '__return_false' );
?>